
#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>

class GLWidget : public QGLWidget
{

public:
    GLWidget(QWidget * father = 0);
    ~GLWidget();

    QSize minimumSizeHint() const;
    QSize sizeHint() const;

protected:
    virtual void initializeGL();
    virtual void paintGL();
    virtual void resizeGL( int width, int height );
	virtual void mousePressEvent( QMouseEvent *event );
	virtual void mouseMoveEvent( QMouseEvent *event );
    virtual void keyPressEvent ( QKeyEvent * event );

    void setBackgroundColor(float v);

private:
	void drawTetrahedron();
    void getNormal(GLfloat normal[3], const GLfloat v0[3], const GLfloat v1[3], const GLfloat v2[3]);

	float m_RotationMatrix[16];
	float m_xTrans, m_yTrans, m_zTrans;
    QPoint m_lastPos;
	float m_backgroundcolor[3];
};

#endif
